this.name        = "oolite-save-reputation";
this.author      = "Mae Stro";
this.copyright   = "(c) 2013 Mae Stro";
this.description = "Change reputation erosion by time";
this.version     = "1.77";

// prop: Contract, Passenger, Parcel

this._increaseReputationBy = function(prop, by)
{  if (!by) return 0;
   var
      f = prop + 'Reputation',
      p = prop.toLowerCase() + 'Reputation',
      i = 'increase' + f,
      d = 'decrease' + f,
      t = Math.min(7, player[p] + by),    // target amount
      r = t - player[p];                  // rest of by

   while ( player[p] != t) { player[i](); if ( player[p] > t) player[d](); }
   return (by-r);
}

this._reputation2log = function()
{
   log( this.name, 
       'Contract:'  + player.contractReputation  +'/'+ this.$extra_reputations.Contract.p  +':'+ this.$extra_reputations.Contract.d +
      ' Passenger:' + player.passengerReputation +'/'+ this.$extra_reputations.Passenger.p +':'+ this.$extra_reputations.Passenger.d +
      ' Parcel:'    + player.parcelReputation    +'/'+ this.$extra_reputations.Parcel.p    +':'+ this.$extra_reputations.Parcel.d
   );
}

this.startUp = function()
{
   this.$award_is_possible = false;
   this.$extra_reputations = missionVariables.oolite_save_reputation ?
      JSON.parse( missionVariables.oolite_save_reputation ) :
      { Contract: { p:0,d:30 }, Passenger: { p:0,d:30 }, Parcel: { p:0,d:30 }};
}

this.playerWillSaveGame = function()
{
   missionVariables.oolite_save_reputation = JSON.stringify(this.$extra_reputations);
}

this.dayChanged = function(newday)
{  log( this.name, 'dayChanged');

   for (i in this.$extra_reputations)
   {  if (!this.$extra_reputations.hasOwnProperty(i)) continue;
      if (! --this.$extra_reputations[i].d)
      {
         log( this.name, 'Decrease reputation for '+i);

         this.$extra_reputations[i].d = 14 + 4 * player[i.toLowerCase() + 'Reputation'];
         if (this.$extra_reputations[i].p)
            this.$extra_reputations[i].p = Math.min(15, this.$extra_reputations[i].p) - 1;    // 15 - limit for extra reputation points
         else
            player['decrease'+i+'Reputation']();

         this._reputation2log();
      }
   }
}

// Temporary decreese reputation for potencial bonuces

this.shipWillDockWithStation = function(station)
{
   log( this.name, 'shipWillDockWithStation:');

   this.$award_is_possible = true;

   this.$save_reputations =
   {  Contract:  player.contractReputation,
      Passenger: player.passengerReputation,
      Parcel:    player.parcelReputation
   };

   for (i in this.$extra_reputations)
   {  if (!this.$extra_reputations.hasOwnProperty(i)) continue;   // prototype prop

      var prop = i.toLowerCase() + 'Reputation';
      if ( player[prop] == 7 )
      {  player['decrease'+i+'Reputation']();
         this.$extra_reputations[i].p += this.$save_reputations[i] - player[prop];
      }
   }
   this._reputation2log();
}


this.missionScreenOpportunity = function()
{  if (! this.$award_is_possible) return;

   log( this.name, 'missionScreenOpportunity:');
   this._reputation2log();

   // rebalance reputation

   for (i in this.$extra_reputations)
   {  if (!this.$extra_reputations.hasOwnProperty(i)) continue;
      this.$extra_reputations[i].p = this._increaseReputationBy(i, this.$extra_reputations[i].p);
   }
   this.$award_is_possible = false;

   log( this.name, 'new:');
   this._reputation2log();

   // display_reputation.oxp 

   if ( worldScripts['display-reputation-contract' ]) worldScripts['display-reputation-contract' ].reset();
   if ( worldScripts['display-reputation-passenger']) worldScripts['display-reputation-passenger'].reset();
}

// JUMPS

// Preserve reputation

this.shipWillEnterWitchspace = function(cause)
{
   log( this.name, 'shipWillEnterWitchspace:');
   this.$save_reputations =
   {  Contract:  player.contractReputation,
      Passenger: player.passengerReputation,
      Parcel:    player.parcelReputation
   };
   log( this.name, 'saved reputation: ' + JSON.stringify(this.$save_reputations ));
}

// Restore reputation

this.shipWillExitWitchspace = function()
{
   log( this.name, 'shipWillExitedWitchspace:');
   log( this.name, 'saved reputation: ' + JSON.stringify(this.$save_reputations ));
   this._reputation2log();

   for (i in this.$save_reputations)
   {  if (!this.$save_reputations.hasOwnProperty(i)) continue;

      var new_value = player[i.toLowerCase() + 'Reputation'];
      if ( new_value >= this.$save_reputations[i]) continue;

      log( this.name, i + ' erosion detected');
      this._increaseReputationBy(i, this.$save_reputations[i] - new_value);

      // Reset contracts for system
/*
"oolite-contracts-cargo";
"oolite-contracts-passengers";
"oolite-contracts-parcels";

this._initialiseCargoContractsForSystem
this._initialiseParcelContractsForSystem
this._initialisePassengerContractsForSystem
*/
      var nm_script = 'oolite-contracts-' + { Contract: 'cargo', Passenger: 'passengers', Parcel: 'parcels'}[i],
          nm_method = '_initialise'+        { Contract: 'Cargo', Passenger: 'Passenger',  Parcel: 'Parcel' }[i] + 'ContractsForSystem';

      if ( worldScripts[nm_script]) worldScripts[nm_script][nm_method]();
   }
   log( this.name, 'new:');
   this._reputation2log();
}
